Index: contrib/ipfilter/parse.c
===================================================================
RCS file: /cvs/DragonFly/src/contrib/ipfilter/parse.c,v
retrieving revision 1.1
diff -u -p -u -r1.1 parse.c
--- contrib/ipfilter/parse.c	17 Jun 2003 02:44:52 -0000	1.1
+++ contrib/ipfilter/parse.c	17 Jul 2004 04:55:54 -0000
@@ -68,10 +68,16 @@ extern	u_char	flags[];
 /* parse()
  *
  * parse a line read from the input filter rule file
+ *
+ * status:
+ *	< 0	error
+ *	= 0	OK
+ *	> 0	programmer error
  */
-struct	frentry	*parse(line, linenum)
+struct	frentry	*parse(line, linenum, status)
 char	*line;
 int     linenum;
+int	*status;	/* good, bad, or indifferent */
 {
 	static	struct	frentry	fil;
 	char	*cps[31], **cpp, *endptr, *s;
@@ -79,10 +85,14 @@ int     linenum;
 	int	i, cnt = 1, j, ch;
 	u_int	k;
 
+	*status = 100;	/* default to error */
+
 	while (*line && isspace(*line))
 		line++;
-	if (!*line)
+	if (!*line) {
+		*status = 0;
 		return NULL;
+	}
 
 	bzero((char *)&fil, sizeof(fil));
 	fil.fr_mip.fi_v = 0xf;
@@ -100,6 +110,7 @@ int     linenum;
 
 	if (cnt < 3) {
 		fprintf(stderr, "%d: not enough segments in line\n", linenum);
+		*status = -1;
 		return NULL;
 	}
 
@@ -143,6 +154,7 @@ int     linenum;
 					fprintf(stderr,
 					"%d: unrecognised icmp code %s\n",
 						linenum, *cpp + 20);
+					*status = -1;
 					return NULL;
 				}
 				fil.fr_icode = j;
@@ -172,6 +184,7 @@ int     linenum;
 		else {
 			fprintf(stderr, "%d: integer must follow skip\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 	} else if (!strcasecmp("log", *cpp)) {
@@ -190,8 +203,11 @@ int     linenum;
 		}
 		if (!strcasecmp(*(cpp+1), "level")) {
 			cpp++;
-			if (loglevel(cpp, &fil.fr_loglevel, linenum) == -1)
+			if (loglevel(cpp, &fil.fr_loglevel, linenum) == -1) {
+				/* NB loglevel prints its own error message */
+				*status = -1;
 				return NULL;
+			}
 			cpp++;
 		}
 	} else {
@@ -199,10 +215,12 @@ int     linenum;
 		 * Doesn't start with one of the action words
 		 */
 		fprintf(stderr, "%d: unknown keyword (%s)\n", linenum, *cpp);
+		*status = -1;
 		return NULL;
 	}
 	if (!*++cpp) {
 		fprintf(stderr, "%d: missing 'in'/'out' keyword\n", linenum);
+		*status = -1;
 		return NULL;
 	}
 
@@ -218,16 +236,19 @@ int     linenum;
 			fprintf(stderr,
 				"%d: Can only use return-icmp with 'in'\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		} else if (fil.fr_flags & FR_RETRST) {
 			fprintf(stderr,
 				"%d: Can only use return-rst with 'in'\n", 
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 	}
 	if (!*++cpp) {
 		fprintf(stderr, "%d: missing source specification\n", linenum);
+		*status = -1;
 		return NULL;
 	}
 
@@ -235,6 +256,7 @@ int     linenum;
 		if (!*++cpp) {
 			fprintf(stderr, "%d: missing source specification\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 		if (fil.fr_flags & FR_PASS)
@@ -254,14 +276,17 @@ int     linenum;
 				fprintf(stderr,
 					"%d: or-block must be used with pass\n",
 					linenum);
+				*status = -1;
 				return NULL;
 			}
 			fil.fr_flags |= FR_LOGORBLOCK;
 			cpp++;
 		}
 		if (*cpp && !strcasecmp(*cpp, "level")) {
-			if (loglevel(cpp, &fil.fr_loglevel, linenum) == -1)
+			if (loglevel(cpp, &fil.fr_loglevel, linenum) == -1) {
+				*status = -1;
 				return NULL;
+			}
 			cpp++;
 			cpp++;
 		}
@@ -271,6 +296,7 @@ int     linenum;
 		if (fil.fr_skip != 0) {
 			fprintf(stderr, "%d: cannot use skip with quick\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 		cpp++;
@@ -287,6 +313,7 @@ int     linenum;
 		if (!*++cpp) {
 			fprintf(stderr, "%d: interface name missing\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 
@@ -307,28 +334,35 @@ int     linenum;
 				fprintf(stderr,
 					"%d: %s can only be used with TCP\n",
 					linenum, "return-rst");
+				*status = -1;
 				return NULL;
 			}
+			*status = 0;
 			return &fil;
 		}
 
 		if (*cpp) {
 			if (!strcasecmp(*cpp, "dup-to") && *(cpp + 1)) {
 				cpp++;
-				if (to_interface(&fil.fr_dif, *cpp, linenum))
+				if (to_interface(&fil.fr_dif, *cpp, linenum)) {
+					*status = -1;
 					return NULL;
+				}
 				cpp++;
 			}
 			if (*cpp && !strcasecmp(*cpp, "to") && *(cpp + 1)) {
 				cpp++;
-				if (to_interface(&fil.fr_tif, *cpp, linenum))
+				if (to_interface(&fil.fr_tif, *cpp, linenum)) {
+					*status = -1;
 					return NULL;
+				}
 				cpp++;
 			} else if (*cpp && !strcasecmp(*cpp, "fastroute")) {
 				if (!(fil.fr_flags & FR_INQUE)) {
 					fprintf(stderr,
 						"can only use %s with 'in'\n",
 						"fastroute");
+					*status = -1;
 					return NULL;
 				}
 				fil.fr_flags |= FR_FASTROUTE;
@@ -366,6 +400,7 @@ int     linenum;
 	if (*cpp && !strcasecmp(*cpp, "tos")) {
 		if (!*++cpp) {
 			fprintf(stderr, "%d: tos missing value\n", linenum);
+			*status = -1;
 			return NULL;
 		}
 		fil.fr_tos = strtol(*cpp, NULL, 0);
@@ -377,6 +412,7 @@ int     linenum;
 		if (!*++cpp) {
 			fprintf(stderr, "%d: ttl missing hopcount value\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 		if (ratoi(*cpp, &i, 0, 255))
@@ -384,6 +420,7 @@ int     linenum;
 		else {
 			fprintf(stderr, "%d: invalid ttl (%s)\n",
 				linenum, *cpp);
+			*status = -1;
 			return NULL;
 		}
 		fil.fr_mip.fi_ttl = 0xff;
@@ -397,6 +434,7 @@ int     linenum;
 	if (*cpp && !strcasecmp(*cpp, "proto")) {
 		if (!*++cpp) {
 			fprintf(stderr, "%d: protocol name missing\n", linenum);
+			*status = -1;
 			return NULL;
 		}
 		proto = *cpp++;
@@ -412,6 +450,7 @@ int     linenum;
 				fprintf(stderr,
 					"%d: unknown protocol (%s)\n",
 					linenum, proto);
+				*status = -1;
 				return NULL;
 			}
 			if (p)
@@ -422,6 +461,7 @@ int     linenum;
 					fprintf(stderr,
 						"%d: unknown protocol (%s)\n",
 						linenum, proto);
+					*status = -1;
 					return NULL;		
 				}
 				fil.fr_proto = i;
@@ -433,6 +473,7 @@ int     linenum;
 	    ((fil.fr_flags & FR_RETMASK) == FR_RETRST)) {
 		fprintf(stderr, "%d: %s can only be used with TCP\n",
 			linenum, "return-rst");
+		*status = -1;
 		return NULL;
 	}
 
@@ -442,21 +483,26 @@ int     linenum;
 
 	if (!*cpp) {
 		fprintf(stderr, "%d: missing source specification\n", linenum);
+		*status = -1;
 		return NULL;
 	}
 	if (!strcasecmp(*cpp, "all")) {
 		cpp++;
-		if (!*cpp)
+		if (!*cpp) {
+			*status = 0;
 			return &fil;
+		}
 	} else {
 		if (strcasecmp(*cpp, "from")) {
 			fprintf(stderr, "%d: unexpected keyword (%s) - from\n",
 				linenum, *cpp);
+			*status = -1;
 			return NULL;
 		}
 		if (!*++cpp) {
 			fprintf(stderr, "%d: missing host after from\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 		if (!strcmp(*cpp, "!")) {
@@ -465,6 +511,7 @@ int     linenum;
 				fprintf(stderr,
 					"%d: missing host after from\n",
 					linenum);
+				*status = -1;
 				return NULL;
 			}
 		} else if (**cpp == '!') {
@@ -475,6 +522,7 @@ int     linenum;
 		if (hostmask(&cpp, (u_32_t *)&fil.fr_src,
 			     (u_32_t *)&fil.fr_smsk, &fil.fr_sport, &ch,
 			     &fil.fr_stop, linenum)) {
+			*status = -1;
 			return NULL;
 		}
 
@@ -484,12 +532,14 @@ int     linenum;
 			fprintf(stderr,
 				"%d: cannot use port and neither tcp or udp\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 
 		fil.fr_scmp = ch;
 		if (!*cpp) {
 			fprintf(stderr, "%d: missing to fields\n", linenum);
+			*status = -1;
 			return NULL;
 		}
 
@@ -499,10 +549,12 @@ int     linenum;
 		if (strcasecmp(*cpp, "to")) {
 			fprintf(stderr, "%d: unexpected keyword (%s) - to\n",
 				linenum, *cpp);
+			*status = -1;
 			return NULL;
 		}
 		if (!*++cpp) {
 			fprintf(stderr, "%d: missing host after to\n", linenum);
+			*status = -1;
 			return NULL;
 		}
 		ch = 0;
@@ -512,6 +564,7 @@ int     linenum;
 				fprintf(stderr,
 					"%d: missing host after from\n",
 					linenum);
+				*status = -1;
 				return NULL;
 			}
 		} else if (**cpp == '!') {
@@ -521,6 +574,7 @@ int     linenum;
 		if (hostmask(&cpp, (u_32_t *)&fil.fr_dst,
 			     (u_32_t *)&fil.fr_dmsk, &fil.fr_dport, &ch,
 			     &fil.fr_dtop, linenum)) {
+			*status = -1;
 			return NULL;
 		}
 		if ((ch != 0) && (fil.fr_proto != IPPROTO_TCP) &&
@@ -529,6 +583,7 @@ int     linenum;
 			fprintf(stderr,
 				"%d: cannot use port and neither tcp or udp\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 
@@ -542,20 +597,25 @@ int     linenum;
 	if (fil.fr_proto && (fil.fr_dcmp || fil.fr_scmp) &&
 	    fil.fr_proto != IPPROTO_TCP && fil.fr_proto != IPPROTO_UDP) {
 		fprintf(stderr, "%d: port operation on non tcp/udp\n", linenum);
+		*status = -1;
 		return NULL;
 	}
 	if (fil.fr_icmp && fil.fr_proto != IPPROTO_ICMP) {
 		fprintf(stderr, "%d: icmp comparisons on wrong protocol\n",
 			linenum);
+		*status = -1;
 		return NULL;
 	}
 
-	if (!*cpp)
+	if (!*cpp) {
+		*status = 0;
 		return &fil;
+	}
 
 	if (*cpp && !strcasecmp(*cpp, "flags")) {
 		if (!*++cpp) {
 			fprintf(stderr, "%d: no flags present\n", linenum);
+			*status = -1;
 			return NULL;
 		}
 		fil.fr_tcpf = tcp_flags(*cpp, &fil.fr_tcpfm, linenum);
@@ -567,8 +627,10 @@ int     linenum;
 	 */
 	if ((fil.fr_v == 4) && *cpp && (!strcasecmp(*cpp, "with") ||
 	     !strcasecmp(*cpp, "and")))
-		if (extras(&cpp, &fil, linenum))
+		if (extras(&cpp, &fil, linenum)) {
+			*status = -1;
 			return NULL;
+		}
 
 	/*
 	 * icmp types for use with the icmp protocol
@@ -579,10 +641,13 @@ int     linenum;
 			fprintf(stderr,
 				"%d: icmp with wrong protocol (%d)\n",
 				linenum, fil.fr_proto);
+			*status = -1;
 			return NULL;
 		}
-		if (addicmp(&cpp, &fil, linenum))
+		if (addicmp(&cpp, &fil, linenum)) {
+			*status = -1;
 			return NULL;
+		}
 		fil.fr_icmp = htons(fil.fr_icmp);
 		fil.fr_icmpm = htons(fil.fr_icmpm);
 	}
@@ -591,8 +656,10 @@ int     linenum;
 	 * Keep something...
 	 */
 	while (*cpp && !strcasecmp(*cpp, "keep"))
-		if (addkeep(&cpp, &fil, linenum))
+		if (addkeep(&cpp, &fil, linenum)) {
+			*status = -1;
 			return NULL;
+		}
 
 	/*
 	 * This is here to enforce the old interface binding behaviour.
@@ -614,10 +681,12 @@ int     linenum;
 		if (fil.fr_skip != 0) {
 			fprintf(stderr, "%d: cannot use skip with head\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 		if (!*++cpp) {
 			fprintf(stderr, "%d: head without group #\n", linenum);
+			*status = -1;
 			return NULL;
 		}
 		if (ratoui(*cpp, &k, 0, UINT_MAX))
@@ -625,6 +694,7 @@ int     linenum;
 		else {
 			fprintf(stderr, "%d: invalid group (%s)\n",
 				linenum, *cpp);
+			*status = -1;
 			return NULL;
 		}
 		cpp++;
@@ -637,6 +707,7 @@ int     linenum;
 		if (!*++cpp) {
 			fprintf(stderr, "%d: group without group #\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 		if (ratoui(*cpp, &k, 0, UINT_MAX))
@@ -644,6 +715,7 @@ int     linenum;
 		else {
 			fprintf(stderr, "%d: invalid group (%s)\n",
 				linenum, *cpp);
+			*status = -1;
 			return NULL;
 		}
 		cpp++;
@@ -657,6 +729,7 @@ int     linenum;
 		for (; *cpp; cpp++)
 			fprintf(stderr, "%s ", *cpp);
 		fprintf(stderr, "]\n");
+		*status = -1;
 		return NULL;
 	}
 
@@ -665,6 +738,7 @@ int     linenum;
 	 */
 	if ((fil.fr_tcpf || fil.fr_tcpfm) && fil.fr_proto != IPPROTO_TCP) {
 		fprintf(stderr, "%d: TCP protocol not specified\n", linenum);
+		*status = -1;
 		return NULL;
 	}
 	if (!(fil.fr_ip.fi_fl & FI_TCPUDP) && (fil.fr_proto != IPPROTO_TCP) &&
@@ -676,6 +750,7 @@ int     linenum;
 			fprintf(stderr,
 				"%d: port comparisons for non-TCP/UDP\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 	}
@@ -685,9 +760,11 @@ int     linenum;
 		fprintf(stderr,
 			"%d: must use 'with frags' with 'keep frags'\n",
 			linenum);
+		*status = -1;
 		return NULL;
 	}
 */
+	*status = 0;
 	return &fil;
 }
 
Index: contrib/ipfilter/printnat.c
===================================================================
RCS file: /cvs/DragonFly/src/contrib/ipfilter/printnat.c,v
retrieving revision 1.1
diff -u -p -u -r1.1 printnat.c
--- contrib/ipfilter/printnat.c	17 Jun 2003 02:44:52 -0000	1.1
+++ contrib/ipfilter/printnat.c	17 Jul 2004 04:55:54 -0000
@@ -58,7 +58,7 @@ extern	char	*sys_errlist[];
 #endif
 
 #if !defined(lint)
-static const char rcsid[] = "@(#)$Id: printnat.c,v 1.1.2.13 2002/12/06 11:40:27 darrenr Exp $";
+static const char rcsid[] = "@(#)$Id: printnat.c,v 1.1.2.15 2003/03/22 15:31:49 darrenr Exp $";
 #endif
 
 
@@ -399,7 +399,6 @@ int opts;
 			       np->in_space, np->in_flags,
 			       np->in_pmax, np->in_use);
 	} else {
-		np->in_nextip.s_addr = htonl(np->in_nextip.s_addr);
 		if (!(np->in_flags & IPN_FILTER)) {
 			printf("%s/", inet_ntoa(np->in_in[0]));
 			bits = countbits(np->in_in[1].s_addr);
@@ -422,6 +421,8 @@ int opts;
 		}
 		if (*np->in_plabel) {
 			printf(" proxy port");
+			if (np->in_dcmp != 0)
+				np->in_dport = htons(np->in_dport);
 			if (np->in_dport != 0) {
 				if (pr != NULL)
 					sv = getservbyport(np->in_dport,
@@ -473,8 +474,12 @@ int opts;
 			printf(" age %d/%d", np->in_age[0], np->in_age[1]);
 		printf("\n");
 		if (opts & OPT_DEBUG) {
+			struct in_addr nip;
+
+			nip.s_addr = htonl(np->in_nextip.s_addr);
+
 			printf("\tspace %lu nextip %s pnext %d", np->in_space,
-			       inet_ntoa(np->in_nextip), np->in_pnext);
+			       inet_ntoa(nip), np->in_pnext);
 			printf(" flags %x use %u\n",
 			       np->in_flags, np->in_use);
 		}
Index: contrib/ipfilter/printstate.c
===================================================================
RCS file: /cvs/DragonFly/src/contrib/ipfilter/printstate.c,v
retrieving revision 1.1
diff -u -p -u -r1.1 printstate.c
--- contrib/ipfilter/printstate.c	17 Jun 2003 02:44:52 -0000	1.1
+++ contrib/ipfilter/printstate.c	17 Jul 2004 04:55:54 -0000
@@ -47,22 +47,26 @@ int opts;
 #else
 	PRINTF("\tpkts %ld bytes %ld", ips.is_pkts, ips.is_bytes);
 #endif
-	if (ips.is_p == IPPROTO_TCP)
+	if (ips.is_p == IPPROTO_TCP) {
 #if defined(NetBSD) && (NetBSD >= 199905) && (NetBSD < 1991011) || \
 (__FreeBSD_version >= 220000) || defined(__OpenBSD__)
-		PRINTF("\t%hu -> %hu %x:%x %u<<%d:%u<<%d",
+		PRINTF("\t%hu -> %hu %x:%x (max %x:%x)\n",
 			ntohs(ips.is_sport), ntohs(ips.is_dport),
 			ips.is_send, ips.is_dend,
+			ips.is_maxsend, ips.is_maxdend);
+		PRINTF("\t%u<<%d:%u<<%d",
 			ips.is_maxswin>>ips.is_swscale, ips.is_swscale,
 			ips.is_maxdwin>>ips.is_dwscale, ips.is_dwscale);
 #else
-		PRINTF("\t%hu -> %hu %x:%x %u<<%d:%u<<%d",
+		PRINTF("\t%hu -> %hu %x:%x (max %x:%x)\n",
 			ntohs(ips.is_sport), ntohs(ips.is_dport),
 			ips.is_send, ips.is_dend,
+			ips.is_maxsend, ips.is_maxdend);
+		PRINTF("\t%u<<%d:%u<<%d",
 			ips.is_maxswin>>ips.is_swscale, ips.is_swscale,
 			ips.is_maxdwin>>ips.is_dwscale, ips.is_dwscale);
 #endif
-	else if (ips.is_p == IPPROTO_UDP)
+	} else if (ips.is_p == IPPROTO_UDP)
 		PRINTF(" %hu -> %hu", ntohs(ips.is_sport),
 			ntohs(ips.is_dport));
 	else if (ips.is_p == IPPROTO_ICMP
Index: contrib/ipfilter/BSD/kupgrade
===================================================================
RCS file: /cvs/DragonFly/src/contrib/ipfilter/BSD/kupgrade,v
retrieving revision 1.1
diff -u -p -u -r1.1 kupgrade
--- contrib/ipfilter/BSD/kupgrade	17 Jun 2003 02:44:52 -0000	1.1
+++ contrib/ipfilter/BSD/kupgrade	17 Jul 2004 04:55:54 -0000
@@ -16,6 +16,9 @@ if [ $os = FreeBSD ] ; then
 		echo "Copying /usr/include/osreldate.h to /sys/sys"
 		cp /usr/include/osreldate.h /sys/sys
 	fi
+	if [ -f /sys/contrib/ipfilter/netinet/mlfk_ipl.c ] ; then
+		/bin/cp mlfk_ipl.c /sys/contrib/ipfilter/netinet/
+	fi
 fi
 archdir="/sys/arch/$karch"
 ipfdir=/sys/netinet
Index: contrib/ipfilter/iplang/iplang_l.l
===================================================================
RCS file: /cvs/DragonFly/src/contrib/ipfilter/iplang/iplang_l.l,v
retrieving revision 1.1
diff -u -p -u -r1.1 iplang_l.l
--- contrib/ipfilter/iplang/iplang_l.l	17 Jun 2003 02:44:53 -0000	1.1
+++ contrib/ipfilter/iplang/iplang_l.l	17 Jul 2004 04:55:54 -0000
@@ -6,7 +6,7 @@
  * provided that this notice is preserved and due credit is given
  * to the original author and the contributors.
  *
- * $Id: iplang_l.l,v 2.2 2000/02/18 00:18:05 darrenr Exp $
+ * $Id: iplang_l.l,v 2.2.2.1 2003/07/28 01:15:59 darrenr Exp $
  */
 #include <stdio.h>
 #include <string.h>
@@ -318,5 +318,6 @@ void swallow()
 		while ((c != '\n') && (c != EOF))
 			c = input();
 	}
-	unput(c);
+	if (c != EOF)
+		unput(c);
 }
Index: contrib/ipfilter/ipsend/ipsend.c
===================================================================
RCS file: /cvs/DragonFly/src/contrib/ipfilter/ipsend/ipsend.c,v
retrieving revision 1.2
diff -u -p -u -r1.2 ipsend.c
--- contrib/ipfilter/ipsend/ipsend.c	17 Jun 2003 04:24:02 -0000	1.2
+++ contrib/ipfilter/ipsend/ipsend.c	17 Jul 2004 04:55:54 -0000
@@ -1,5 +1,5 @@
 /* $FreeBSD: src/contrib/ipfilter/ipsend/ipsend.c,v 1.4.2.5 2003/03/01 03:55:53 darrenr Exp $ */
-/* $DragonFly: src/contrib/ipfilter/ipsend/ipsend.c,v 1.2 2003/06/17 04:24:02 dillon Exp $ */
+/* $FreeBSD: src/contrib/ipfilter/ipsend/ipsend.c,v 1.4.2.6 2004/07/04 09:24:40 darrenr Exp $ */
 /*
  * ipsend.c (C) 1995-1998 Darren Reed
  *
@@ -26,8 +26,10 @@
 #include <arpa/inet.h>
 #include <netinet/in_systm.h>
 #include <netinet/ip.h>
+#include <netinet/ip_var.h>
 #include <netinet/tcp.h>
 #include <netinet/udp.h>
+#include <netinet/udp_var.h>
 #include <netinet/ip_icmp.h>
 #ifndef	linux
 #include <netinet/ip_var.h>
@@ -71,6 +73,7 @@ char	default_device[] = "lan0";
 
 static	void	usage __P((char *));
 static	void	do_icmp __P((ip_t *, char *));
+void udpcksum(ip_t *, struct udphdr *, int);
 int	main __P((int, char **));
 
 
@@ -170,6 +173,37 @@ struct in_addr gwip;
 	return send_packet(wfd, mtu, ip, gwip);
 }
 
+void
+udpcksum(ip_t *ip, struct udphdr *udp, int len)
+{
+	union pseudoh {
+		struct hdr {
+			u_short len;
+			u_char ttl;
+			u_char proto;
+			u_32_t src;
+			u_32_t dst;
+		} h;
+		u_short w[6];
+	} ph;
+	u_32_t temp32;
+	u_short cksum, *opts;
+
+	ph.h.len = htons(len);
+	ph.h.ttl = 0;
+	ph.h.proto = IPPROTO_UDP;
+	ph.h.src = ip->ip_src.s_addr;
+	ph.h.dst = ip->ip_dst.s_addr;
+	temp32 = 0;
+	opts = &ph.w[0];
+	temp32 += opts[0] + opts[1] + opts[2] + opts[3] + opts[4] + opts[5];
+	temp32 = (temp32 >> 16) + (temp32 & 65535);
+	temp32 += (temp32 >> 16);
+	udp->uh_sum = temp32 & 65535;
+	udp->uh_sum = chksum((u_short *)udp, len);
+	if (udp->uh_sum == 0)
+		udp->uh_sum = 0xffff;
+}
 
 int main(argc, argv)
 int	argc;
@@ -177,8 +211,10 @@ char	**argv;
 {
 	FILE	*langfile = NULL;
 	struct	tcpiphdr *ti;
+	struct	udpiphdr *ui;
 	struct	in_addr	gwip;
 	tcphdr_t	*tcp;
+	udphdr_t	*udp;
 	ip_t	*ip;
 	char	*name =  argv[0], host[MAXHOSTNAMELEN + 1];
 	char	*gateway = NULL, *dev = NULL;
@@ -190,7 +226,10 @@ char	**argv;
 	 */
 	ip = (ip_t *)calloc(1, 65536);
 	ti = (struct tcpiphdr *)ip;
+	ui = (struct udpiphdr *)ip;
 	tcp = (tcphdr_t *)&ti->ti_sport;
+	udp = (udphdr_t *)&ui->ui_sport;
+	ui->ui_ulen = htons(sizeof(*udp));
 	ip->ip_len = sizeof(*ip);
 	ip->ip_hl = sizeof(*ip) >> 2;
 
@@ -344,27 +383,35 @@ char	**argv;
 		exit(2);
 	    }
 
+	if (ip->ip_p != IPPROTO_TCP && ip->ip_p != IPPROTO_UDP) {
+		fprintf(stderr,"Unsupported protocol %d\n", ip->ip_p);
+		exit(2);
+	}
+
 	if (olen)
 	    {
-		caddr_t	ipo = (caddr_t)ip;
+		int hlen;
+		char *p;
 
 		printf("Options: %d\n", olen);
-		ti = (struct tcpiphdr *)malloc(olen + ip->ip_len);
-		if(!ti)
+		hlen = sizeof(*ip) + olen;
+		ip->ip_hl = hlen >> 2;
+		ip->ip_len += olen;
+		p = (char *)malloc(65536);
+		if(!p)
 		    {
 			fprintf(stderr,"malloc failed\n");
 			exit(2);
 		    } 
-
-		bcopy((char *)ip, (char *)ti, sizeof(*ip));
-		ip = (ip_t *)ti;
-		ip->ip_hl = (olen >> 2);
-		bcopy(options, (char *)(ip + 1), olen);
-		bcopy((char *)tcp, (char *)(ip + 1) + olen, sizeof(*tcp));
-		ip->ip_len += olen;
-		bcopy((char *)ip, (char *)ipo, ip->ip_len);
-		ip = (ip_t *)ipo;
-		tcp = (tcphdr_t *)((char *)(ip + 1) + olen);
+		bcopy(ip, p, sizeof(*ip));
+		bcopy(options, p + sizeof(*ip), olen);
+		bcopy(ip + 1, p + hlen, ip->ip_len - hlen);
+		ip = (ip_t *)p;
+		if (ip->ip_p == IPPROTO_TCP) {
+			tcp = (tcphdr_t *)((char *)ip + hlen);
+		} else {
+			udp = (udphdr_t *)((char *)ip + hlen);
+		}
 	    }
 
 	if (ip->ip_p == IPPROTO_TCP)
@@ -401,9 +448,13 @@ char	**argv;
 		printf("Flags:   %#x\n", tcp->th_flags);
 	printf("mtu:     %d\n", mtu);
 
+	if (ip->ip_p == IPPROTO_UDP) {
+		udp->uh_sum = 0;
+		udpcksum(ip, udp, (ip->ip_len) - (ip->ip_hl << 2));
+	}
 #ifdef	DOSOCKET
-	if (tcp->th_dport)
-		return do_socket(dev, mtu, ti, gwip);
+	if (ip->ip_p == IPPROTO_TCP && tcp->th_dport)
+		return do_socket(dev, mtu, (struct tcpiphdr *)ip, gwip);
 #endif
-	return send_packets(dev, mtu, (ip_t *)ti, gwip);
+	return send_packets(dev, mtu, ip, gwip);
 }
Index: contrib/ipfilter/ipsend/ipsopt.c
===================================================================
RCS file: /cvs/DragonFly/src/contrib/ipfilter/ipsend/ipsopt.c,v
retrieving revision 1.1
diff -u -p -u -r1.1 ipsopt.c
--- contrib/ipfilter/ipsend/ipsopt.c	17 Jun 2003 02:44:54 -0000	1.1
+++ contrib/ipfilter/ipsend/ipsopt.c	17 Jul 2004 04:55:54 -0000
@@ -25,7 +25,7 @@
 
 #if !defined(lint)
 static const char sccsid[] = "@(#)ipsopt.c	1.2 1/11/96 (C)1995 Darren Reed";
-static const char rcsid[] = "@(#)$Id: ipsopt.c,v 2.1.4.4 2002/12/06 11:40:35 darrenr Exp $";
+static const char rcsid[] = "@(#)$Id: ipsopt.c,v 2.1.4.5 2004/04/10 11:50:52 darrenr Exp $";
 #endif
 
 
@@ -98,7 +98,10 @@ char *class;
 			len += val;
 		} else
 			*op++ = io->on_siz;
-		*op++ = IPOPT_MINOFF;
+		if (io->on_value == IPOPT_TS)
+			*op++ = IPOPT_MINOFF + 1;
+		else
+			*op++ = IPOPT_MINOFF;
 
 		while (class && *class) {
 			t = NULL;
Index: contrib/ipfilter/test/Makefile
===================================================================
RCS file: /cvs/DragonFly/src/contrib/ipfilter/test/Makefile,v
retrieving revision 1.1
diff -u -p -u -r1.1 Makefile
--- contrib/ipfilter/test/Makefile	17 Jun 2003 02:44:55 -0000	1.1
+++ contrib/ipfilter/test/Makefile	17 Jul 2004 04:55:54 -0000
@@ -51,7 +51,7 @@ i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12:
 n1 n2 n3 n4 n5 n6 n7:
 	@/bin/sh ./nattest $@
 
-ni1 ni2 ni3 ni4 ni5:
+ni1 ni2 ni3 ni4 ni5 ni7 ni8 ni10 ni11:
 	@/bin/sh ./natipftest $@
 
 in1 in2 in3 in4:
Index: contrib/ipfilter/test/expected/in1
===================================================================
RCS file: /cvs/DragonFly/src/contrib/ipfilter/test/expected/in1,v
retrieving revision 1.1
diff -u -p -u -r1.1 in1
--- contrib/ipfilter/test/expected/in1	17 Jun 2003 02:44:56 -0000	1.1
+++ contrib/ipfilter/test/expected/in1	17 Jul 2004 04:55:54 -0000
@@ -22,3 +22,4 @@ map ppp0 192.168.0.0/16 -> 0.0.0.0/32 po
 map le0 0.0.0.0/0 -> 0.0.0.0/32 frag age 10/10
 map le0 192.168.0.0/16 -> range 203.1.1.23-203.1.3.45 frag age 10/20
 map ppp0 192.168.0.0/16 -> 0.0.0.0/32 portmap tcp 10000:19999 frag age 30/30
+map fxp0 from 192.168.0.0/18 to any port = ftp -> 1.2.3.4/32 proxy port ftp ftp/tcp
Index: contrib/ipfilter/test/expected/ni1
===================================================================
RCS file: /cvs/DragonFly/src/contrib/ipfilter/test/expected/ni1,v
retrieving revision 1.1
diff -u -p -u -r1.1 ni1
--- contrib/ipfilter/test/expected/ni1	17 Jun 2003 02:44:57 -0000	1.1
+++ contrib/ipfilter/test/expected/ni1	17 Jul 2004 04:55:54 -0000
@@ -1,3 +1,4 @@
-4500 0028 4706 4000 0111 ced8 0606 0606 0404 0404 afc9 829e 0014 0b2d 0402 0000 3be5 468d 000a cfc3
-4500 0038 809a 0000 ff01 8f31 0303 0303 0202 0202 0b00 a537 0000 0000 4500 0028 4703 4000 0111 ef89 0202 0202 0404 0404 afc9 829e 0014 1d4f
+4500 0028 4706 4000 0111 1eac 0606 0606 0404 0404 afc9 829e 0014 6308 0402 0000 3be5 468d 000a cfc3
+4500 0038 809a 0000 ff01 3121 0303 0303 0202 0202 0b00 5773 0000 0000 4500 0028 4706 4000 0111 26b4 0202 0202 0404 0404 afc9 829e 0014 6b10
+4500 0044 809a 0000 ff01 3115 0303 0303 0202 0202 0b00 0131 0000 0000 4500 0028 4706 4000 0111 26b4 0202 0202 0404 0404 afc9 829e 0014 6b10 0402 0000 3be5 468d 000a cfc3
 -------------------------------
Index: contrib/ipfilter/test/expected/ni3
===================================================================
RCS file: /cvs/DragonFly/src/contrib/ipfilter/test/expected/ni3,v
retrieving revision 1.1
diff -u -p -u -r1.1 ni3
--- contrib/ipfilter/test/expected/ni3	17 Jun 2003 02:44:57 -0000	1.1
+++ contrib/ipfilter/test/expected/ni3	17 Jul 2004 04:55:54 -0000
@@ -1,4 +1,4 @@
-4500 003c 4706 4000 ff06 28aa 0606 0606 0404 0404 5000 0050 0000 0001 0000 0000 a002 16d0 d0da 0000 0204 05b4 0402 080a 0047 fbb0 0000 0000 0103 0300
-4500 0038 809a 0000 ff01 3323 0303 0303 0202 0202 0303 acab 0000 0000 4500 003c 4706 4000 ff06 28aa 0202 0202 0404 0404 5000 0050 0000 0001
-4500 0058 809a 0000 ff01 3303 0303 0303 0202 0202 0303 0937 0000 0000 4500 003c 4706 4000 ff06 28aa 0202 0202 0404 0404 5000 0050 0000 0001 0000 0000 a002 16d0 d8e2 0000 0204 05b4 0402 080a 0047 fbb0 0000 0000 0103 0300
+4500 003c 4706 4000 ff06 20a2 0606 0606 0404 0404 5000 0050 0000 0001 0000 0000 a002 16d0 d0da 0000 0204 05b4 0402 080a 0047 fbb0 0000 0000 0103 0300
+4500 0038 809a 0000 ff01 3121 0303 0303 0202 0202 0303 acab 0000 0000 4500 003c 4706 4000 ff06 28aa 0202 0202 0404 0404 5000 0050 0000 0001
+4500 0058 809a 0000 ff01 3101 0303 0303 0202 0202 0303 0937 0000 0000 4500 003c 4706 4000 ff06 28aa 0202 0202 0404 0404 5000 0050 0000 0001 0000 0000 a002 16d0 d8e2 0000 0204 05b4 0402 080a 0047 fbb0 0000 0000 0103 0300
 -------------------------------
Index: contrib/ipfilter/test/expected/ni4
===================================================================
RCS file: /cvs/DragonFly/src/contrib/ipfilter/test/expected/ni4,v
retrieving revision 1.1
diff -u -p -u -r1.1 ni4
--- contrib/ipfilter/test/expected/ni4	17 Jun 2003 02:44:57 -0000	1.1
+++ contrib/ipfilter/test/expected/ni4	17 Jul 2004 04:55:54 -0000
@@ -1,4 +1,4 @@
-4500 003c 4706 4000 ff06 28aa 0606 0606 0404 0404 9c40 0050 0000 0001 0000 0000 a002 16d0 849a 0000 0204 05b4 0402 080a 0047 fbb0 0000 0000 0103 0300
-4500 0038 809a 0000 ff01 3323 0303 0303 0202 0202 0303 acab 0000 0000 4500 003c 4706 4000 ff06 28aa 0202 0202 0404 0404 5000 0050 0000 0001
-4500 0058 809a 0000 ff01 3303 0303 0303 0202 0202 0303 0937 0000 0000 4500 003c 4706 4000 ff06 28aa 0202 0202 0404 0404 5000 0050 0000 0001 0000 0000 a002 16d0 d8e2 0000 0204 05b4 0402 080a 0047 fbb0 0000 0000 0103 0300
+4500 003c 4706 4000 ff06 20a2 0606 0606 0404 0404 9c40 0050 0000 0001 0000 0000 a002 16d0 849a 0000 0204 05b4 0402 080a 0047 fbb0 0000 0000 0103 0300
+4500 0038 809a 0000 ff01 3121 0303 0303 0202 0202 0303 acab 0000 0000 4500 003c 4706 4000 ff06 28aa 0202 0202 0404 0404 5000 0050 0000 0001
+4500 0058 809a 0000 ff01 3101 0303 0303 0202 0202 0303 0937 0000 0000 4500 003c 4706 4000 ff06 28aa 0202 0202 0404 0404 5000 0050 0000 0001 0000 0000 a002 16d0 d8e2 0000 0204 05b4 0402 080a 0047 fbb0 0000 0000 0103 0300
 -------------------------------
